#include "Search.h"
/**
 * iI@abstractNX
 * @author Alberto Pawlovsky
 * @author AsWe
 */

	EvolutionaryMethod::EvolutionaryMethod(){
		population = 100;
	};

	EvolutionaryMethod::~EvolutionaryMethod(){
		if( parentGeneration != 0 )
			delete parentGeneration;
		if( childGeneration != 0 )
			delete childGeneration;
	};

	/**
	 * s
	 */
	void EvolutionaryMethod::doSearch() {
		std::cout << "\n# first generation\t";
		firstGeneration();	// 
		evaluateGeneration();	// ̕]
		for( int g=1; g<trials; g++ ){	// 㐔JԂ
			std::cout << "\n# " << g << "\t";
			parentGeneration = childGeneration;	// qeɂȂ
			newGeneration();	// VqY
			evaluateGeneration();	// ̕]
		}
	};

	/**
	 * 㐶
	 *
	 */
	void EvolutionaryMethod::firstGeneration() {
		childGeneration = new CandidateList[population];	// q̗̈
		for( int i=0; i<population; i++ ){	// ̐
			CandidateList member = CandidateList();	// ̐
			member.randomSelect();	// ̏_ɐݒ
			childGeneration[i] = member;	// qɉ
		}
	};

	/**
	 * ̕]FDG̂̒o
	 *
	 */
	void EvolutionaryMethod::evaluateGeneration() {
		CandidateList bestPerson = CandidateList();	// ̒̍ŗDǌ
		int bestValue = 0;	// ̍ōl
		for( int i=0; i<population; i++ ){
			Article* eval = childGeneration[i].getTotals();	// ̂̉lƃRXg𒊏o
			if( eval->getCost() < limit )	// 
				if( eval->getValue() > bestValue ){	// lō
					bestPerson = childGeneration[i];	// ŗǌ̂̍XV
					bestValue = eval->getValue();	// ŗǂ̉lXV
				}
		}
		recordResult( bestPerson );	// ̍ō]̋L^
	};

	/**
	 * lݒ
	 * @param population ݒ肷l
	 */
	void EvolutionaryMethod::setPopulation(int population) {
		this->population = population
			+ ((population % 2 == 1) ? 1 : 0) ;
	};
